<?php
/**
 * Clase Base FN para BaseArBancoFN
 *
 * @package    
 * @subpackage BaseArBancoFN
 * @author     Willy
 * @version    SVN:: BaseArBancoFN.class.php,v 1.1 2020-06-30 13:51:23 william.taype Exp $
 */
class BaseArBancoFN extends ArBancoBN
{
  private static $fieldNames = array (
    'Idbanco'=>'idbanco', 'Descripcion'=>'descripcion', 'Estado'=>'estado', 'Eliminado'=>'eliminado', 'Usuarioeliminado'=>'usuarioeliminado', 'Fechaeliminado'=>'fechaeliminado', 'Fecharegistro'=>'fecharegistro', 'Usuarioregistro'=>'usuarioregistro'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT * FROM ar_banco WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
         $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idbanco, descripcion, estado, eliminado, usuarioeliminado, fechaeliminado, fecharegistro, usuarioregistro FROM ar_banco WHERE 1 ".$where;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdbanco()){ $where .= " AND idbanco = '".$this->getIdbanco()."'"; }
      if($this->getDescripcion()){ $where .= " AND descripcion = '".$this->getDescripcion()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      if($this->getEliminado()){ $where .= " AND eliminado = '".$this->getEliminado()."'"; }
      if($this->getUsuarioeliminado()){ $where .= " AND usuarioeliminado = '".$this->getUsuarioeliminado()."'"; }
      if($this->getFechaeliminado()){ $where .= " AND fechaeliminado = '".$this->getFechaeliminado()."'"; }
      if($this->getFecharegistro()){ $where .= " AND fecharegistro = '".$this->getFecharegistro()."'"; }
      if($this->getUsuarioregistro()){ $where .= " AND usuarioregistro = '".$this->getUsuarioregistro()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idbanco, descripcion, estado, eliminado, usuarioeliminado, fechaeliminado, fecharegistro, usuarioregistro FROM ar_banco WHERE 1 AND idbanco='".$this->getIdbanco()."'; ";
      
         $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseArBancoFN = new BaseArBancoFN();
    $o_BaseArBancoFN->setIdbanco($o_propel->idbanco);
    $o_BaseArBancoFN->setDescripcion($o_propel->descripcion);
    $o_BaseArBancoFN->setEstado($o_propel->estado);
    $o_BaseArBancoFN->setEliminado($o_propel->eliminado);
    $o_BaseArBancoFN->setUsuarioeliminado($o_propel->usuarioeliminado);
    $o_BaseArBancoFN->setFechaeliminado($o_propel->fechaeliminado);
    $o_BaseArBancoFN->setFecharegistro($o_propel->fecharegistro);
    $o_BaseArBancoFN->setUsuarioregistro($o_propel->usuarioregistro);
    $o_BaseArBancoFN->setFechamodificacion($o_propel->fechamodificacion);
    $o_BaseArBancoFN->setUsuariomodificacion($o_propel->usuariomodificacion);
    return $o_BaseArBancoFN;
  }
}